# Pocket

Wrapper for the [zip](https://crates.io/crates/zip) library.

## Todo List

> Last Updated: October 1st, 2024

- [x] Custom Errors via [thiserror](https://crates.io/crates/thiserror)
- [ ] Writing ZIPs
  - [x] Insert File (This will read it itself)
  - [ ] Write File (Give it a path/file/name in the ZIP, and content)
  - [x] Insert Directory (This will read an existing directory)
  - [ ] Make Directory (Create a new path/directory in the ZIP)
- [ ] Reading ZIPs
  - [ ] Grab File (Give an output file/path for the file's contents)
  - [ ] Grab Directory (Creates a output directory, and grabs all files under the directory in the ZIP, you loose renaming the extracted files)
  - [ ] Grab All (Like most ZIP Archivers, Extract All files and directories, under their original names)
  - [ ] Fetch Info (Query certain info from the ZIP)
    - [ ] Iterator to iterate all files/directories within ZIP
    - [ ] Iterator for all files/directories within a specific location inside the ZIP (As `ls` or `dir` behaves in OSes)
    - [ ] Query total files
    - [ ] Query total directories
    - [ ] Query if a file or directory exists

